using System.Drawing;
using System.Text;
using System.Windows.Forms;

using EGIS.Controls;
using EGIS.ShapeFileLib;

namespace TestProject
{
    /// <summary>
    ///  
    /// </summary>
    public partial class MainForm : Form
    {
        //////////////////////////////////////////////////////////////////////////////////////////////////// Constructor
        ////////////////////////////////////////////////////////////////////////////////////////// Public

        #region  - MainForm()

        /// <summary>
        /// 
        /// </summary>
        public MainForm()
        {
            InitializeComponent();

            this.map.ClearShapeFiles();
            
            this.map.AddShapeFile("DATA\\world_adm0.shp", "ShapeFile", "");
            
            ShapeFile shapeFile = this.map[0];

            shapeFile.RenderSettings.FieldName        = shapeFile.RenderSettings.DbfReader.GetFieldNames()[0];
            shapeFile.RenderSettings.UseToolTip       = true;
            shapeFile.RenderSettings.ToolTipFieldName = shapeFile.RenderSettings.FieldName;
            shapeFile.RenderSettings.IsSelectable     = true;
            shapeFile.RenderSettings.Font             = new Font("ڵ", 12f);

            shapeFile.SelectRecord(5, true);

            this.map.MouseClick += map_MouseClick;
        }

        #endregion

        //////////////////////////////////////////////////////////////////////////////////////////////////// Method
        ////////////////////////////////////////////////////////////////////////////////////////// Private

        #region  콺 Ŭ óϱ - map_MouseClick(sender, e)

        /// <summary>
        ///  콺 Ŭ óϱ
        /// </summary>
        /// <param name="sender">̺Ʈ ߻</param>
        /// <param name="e">̺Ʈ </param>
        private void map_MouseClick(object sender, MouseEventArgs e)
        {
            SFMap map = sender as SFMap;

            int recordIndex = map.GetShapeIndexAtPixelCoord(0, e.Location, 8);

            if(recordIndex >= 0)
            {
                string[] attributeFieldValueArray = map[0].GetAttributeFieldValues(recordIndex);
                string[] attributeFieldNameArray  = map[0].GetAttributeFieldNames();

                StringBuilder stringBuilder = new StringBuilder();

                for(int i = 0; i < attributeFieldNameArray.Length; ++i)
                {
                    stringBuilder.Append($"{attributeFieldNameArray[i]}:{attributeFieldValueArray[i].Trim()}");
                }

                MessageBox.Show
                (
                    this,
                    stringBuilder.ToString(),
                    "INFORMATION",
                    MessageBoxButtons.OK,
                    MessageBoxIcon.Information
                );
            }
        }

        #endregion        
    }
}